SystemOrganization addCategory: #'HM4-PokerDice'!

Object subclass: #PokerDiceGame
	instanceVariableNames: 'hand gameBoard throwButton dieViews handSize scoreView throws throwsView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HM4-PokerDice'!

!PokerDiceGame methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/21/2013 14:32'!
initialize
	super initialize.
	hand := Hand new.
	handSize := (hand dice) size.
	dieViews := Array new: handSize.
	1 to: handSize do: [ :i | dieViews at: i put: GameDieView new ].
	1 to: handSize do: [ :i | (dieViews at: i) model: (hand dice at: i) ].
	gameBoard := AlignmentMorph newRow.
	gameBoard borderWidth: 1.
	gameBoard hResizing: #shrinkWrap.
	gameBoard vResizing: #shrinkWrap.
	throwButton := (SimpleButtonMorph new) label: 'throw!!'; target: self; actionSelector: #throwButtonPressed.
	gameBoard addMorph: throwButton.
	1 to: handSize do: [ :i | gameBoard addMorph: (dieViews at: i) ].
	scoreView := TextMorph new.
	gameBoard addMorph: scoreView.
	scoreView contents: hand payout asString.
	throwsView := TextMorph new.
	throws := 0.
	throwsView contents: throws asString.
	gameBoard addMorph: throwsView.! !

!PokerDiceGame methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/20/2013 19:29'!
show
	gameBoard openInWorld.! !

!PokerDiceGame methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/21/2013 14:30'!
throwButtonPressed
	throws := throws + 1.
	1 to: handSize do: [ :i | (dieViews at: i) isMarked ifFalse: [ (dieViews at: i) throwDie ] ].
	scoreView contents: hand payout asString.
	throwsView contents: throws asString.! !

DieView subclass: #GameDieView
	instanceVariableNames: 'marked'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HM4-PokerDice'!

!GameDieView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/21/2013 14:04'!
initialize
	super initialize.
	marked := false.! !

!GameDieView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/21/2013 14:10'!
isMarked
	^ marked.! !

!GameDieView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/21/2013 14:05'!
mouseDown: event 
	marked := marked not.
	self updateMarking.! !

!GameDieView methodsFor: 'as yet unclassified' stamp: 'CameronRieck 2/21/2013 14:16'!
updateMarking
	marked
	ifTrue: [ self borderColor: Color yellow ; color: Color blue ] 
	ifFalse: [ self borderColor: Color black ; color: self defaultColor ]! !
